#
# AC_ETHEREAL_PCAP_CHECK
#
AC_DEFUN(AC_ETHEREAL_PCAP_CHECK,
[
        # Evidently, some systems have pcap.h, etc. in */include/pcap
		AC_ARG_WITH(pcapinclude, [  --with-pcapinclude      directory containing pcap headers], with_pcapdir=${withval})
        AC_MSG_CHECKING(for extraneous pcap header directories)
        found_pcap_dir=""
        for pcap_dir in $with_pcapdir /usr/include/pcap /usr/local/include/pcap $prefix/include
        do
          if test -d $pcap_dir ; then
            CFLAGS="$CFLAGS -I$pcap_dir"
            CPPFLAGS="$CPPFLAGS -I$pcap_dir"
            found_pcap_dir=" $found_pcap_dir -I$pcap_dir"
			PCAP_INC=$pcap_dir
			AC_SUBST(PCAP_INC)
			break
          fi
        done

        if test "$found_pcap_dir" != "" ; then
          AC_MSG_RESULT(found --$found_pcap_dir added to CFLAGS)
        else
          AC_MSG_RESULT(not found)
        fi

        # Pcap header checks
#        AC_CHECK_HEADER(net/bpf.h,,
#            AC_MSG_ERROR([[Header file net/bpf.h not found; if you installed lib
# pcap from source, did you also do \"make install-incl\"?]]))
        AC_CHECK_HEADER(pcap.h,, AC_MSG_ERROR(Header file pcap.h not found.))

        #
        # Check to see if we find "pcap_open_live" in "-lpcap".
        #
		AC_ARG_WITH(pcaplib, [  --with-pcaplib      directory containing pcap libraries], with_pcaplibdir=${withval})
        AC_CHECK_LIB(pcap, pcap_open_live,
          [
			if test "$with_pcaplibdir" != "" ; then
				PCAP_LIBS="-L${with_pcaplibdir} -lpcap"
			else
				PCAP_LIBS=-lpcap
			fi
            AC_DEFINE(HAVE_LIBPCAP)
          ], AC_MSG_ERROR(Library libpcap not found.),
          $SOCKET_LIBS $NSL_LIBS)
        AC_SUBST(PCAP_LIBS)
])
