/* pcap_tcl.h
 * Copyright (c) 2001, Todd J Martin
 * $Id: pcap_tcl.h,v 1.6 2005/01/02 06:39:08 todd Exp $
 */

int Tcl_pcap_open(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_lookupdev(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_lookupnet(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_getPacket(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_packetToString(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_printPacket(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_savefile(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_stats(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_datalink(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_datalink(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_dumpOpen(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_dumpClose(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_dump(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);
int Tcl_pcap_version(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[]);

typedef struct {
	char pcapName[20];
	/* The file descriptor for the capture */
	int fd;
	/* This is 1 if pcap_open_offline called.  0 otherwise */
	int offline;
	/* 0 - nonblocking  1 - blocking */
	int blocking;
	pcap_t *pcapPtr;
	char *filterString;
	char *saveFileName;
	/* 0 is off (not dumping) 1 is on */
	int dumpStatus;
	pcap_dumper_t *pcapDumper;
	Tcl_Channel channel;
} pcapNode;

void createPcapChannel(Tcl_Interp *interp, pcapNode *name);
void captureHandler(u_char *user, const struct pcap_pkthdr* packetHdr, const u_char *packet);
void printPacket(Tcl_Obj *packet);
int pcapGetPacket(Tcl_Channel chan, Tcl_Obj *objPtr);
int pcapGetChannelInstanceData(Tcl_Interp *interp, int objc, 
		Tcl_Obj *CONST objv[], pcapNode **pnode);
int isPcapChannelFromChannel(Tcl_Interp *interp, const Tcl_Channel channel);
int isPcapChannelFromChannelName(Tcl_Interp *interp, const char *channelName);
void deletePcapDumpers(ClientData clientData, Tcl_Interp *interp);



