'\"
'\" Generated from file 'tclpcap.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2001-2005 by Todd J Martin <todd.martin@acm.org>
'\"
.so man.macros
.TH "tclPcap" n 2.0.0 tclPcap "A Tcl interface to the pcap packet capture library"
.BS
.SH "NAME"
tclPcap \- Interface to the PCAP library
.SH "SYNOPSIS"
package require \fBTcl  8.0\fR
.sp
package require \fBPcap  2.0.0\fR
.sp
\fBpcap_open\fR ?\fI-offline\fR? ?\fI-nopromisc\fR? ?\fI-caplength length\fR? ?\fI-filter filter\fR? \fIfileName|deviceName\fR\fR
.sp
\fBlookupdev\fR \fR
.sp
\fBlookupnet\fR \fIdeviceName\fR\fR
.sp
\fBgetPacket\fR \fIpcapChannel\fR\fR
.sp
\fBpacketToString\fR \fIpacket\fR\fR
.sp
\fBprintPacket\fR \fIpacket\fR\fR
.sp
\fBsavefile\fR \fIpcapChannel\fR ?\fIon|off\fR?\fR
.sp
\fBdatalink\fR \fIpcapChannel\fR\fR
.sp
\fBdump_open\fR \fIpcapChannel\fR \fIdumpFileName\fR\fR
.sp
\fBdump\fR \fIpcap_dumper\fR \fIpacket\fR\fR
.sp
\fBdump_close\fR \fIpcap_dumper\fR\fR
.sp
\fBversion\fR \fR
.sp
.BE
.SH "DESCRIPTION"
tclPcap is a set of Tcl commands that provide an interface to the pcap packet
capture library, available on  a  wide  variety  of  platforms.  This
extension  does this by creating a new channel type called pcap.  This allows
for very easy access to the  library.   All  new  commands added to the
interpreter are in the pcap:: namespace.
.TP
\fBpcap_open\fR ?\fI-offline\fR? ?\fI-nopromisc\fR? ?\fI-caplength length\fR? ?\fI-filter filter\fR? \fIfileName|deviceName\fR\fR
Creates a new channel that can be used to read captured packets.  This command
returns the name of the new channel.
.RS
.TP
-offline
The  \fI-offline\fR flag  indicates that data  will not be captured from a
network device.  Instead, a file name will be given that is the name of  a
capture file to read.  This capture file could have been created by tclpcap or
tcpdump (or any other program that uses libpcap).
.TP
-nopromisc
The  \fI-nopromisc\fR  tells tclpcap not to open the capture device in
promiscuous mode.  The option has  no  effect  if  \fI-offline\fR  is given.
.TP
-caplength length
The \fI-caplength\fR option specifies the number of bytes of each frame to
capture.  The default value is 1500.  If  a  negative  number is given, the
default value will be used.
.TP
-filter filter
The \fI-filter\fR specifies a filter string that is to be set for this
capture.  The syntax of the filter is as documented in the tcpdump man page.
If no filter is specified, the string "default" is used, which will capture
all packets on the network.  If the filter cannot be applied to the capture
device, pcap_open will throw an error.
.TP
fileName|deviceName
The last argument is the name of the network  device  to capture  from, unless
\fI-offline\fR has been given.  In that case it is the name of a capture file
to read from.  The special deviceName  of  "any" will cause all network
interfaces to be used for captures.
.RE
.TP
\fBlookupdev\fR \fR
This  calls  pcap_lookupdev  and  returns  the name of a network device that
can be used with \fBpcap_open\fR.  The loopback  interface is  ignored,  and  the
lowest numbered unit is the one returned (assuming multiple devices).
.TP
\fBlookupnet\fR \fIdeviceName\fR\fR
This calls pcap_lookupnet with the supplied network deviceName.  The command
returns a list containing the network address as the first element and the
netmask as the second element.
.TP
\fBgetPacket\fR \fIpcapChannel\fR\fR
This command takes the name of a \fIpcapChannel\fR that was opened with
\fBpcap_open\fR as an argument.  It reads the next available packet and returns
that in a list.  The first element of the list is a header containing
the timestamp and length of the packet.  The next element is the actual data
itself.   The data is a binary string, so it is not useful to print it
out.  See \fBpacketToString\fR and \fBprintPacket\fR.
.sp
It is possible for \fBgetPacket\fR to be unable to read a packet.  In this
case, an empty list will be returned.  The caller should not interpret this to
mean that an end of file has been reached (if reading offline) or that the
network interface is down.  The \fBeof\fR command should be used to detect
this.  Am empty list could be returned even if the channel is in blocking
mode.
.TP
\fBpacketToString\fR \fIpacket\fR\fR
This command takes a \fIpacket\fR, as returned from \fBgetPacket\fR,  as an
argument and returns the captured data as a string.
.TP
\fBprintPacket\fR \fIpacket\fR\fR
This command takes a \fIpacket\fR, as returned from \fBgetPacket\fR, as an argument and
prints the hex values to stdout.
.TP
\fBsavefile\fR \fIpcapChannel\fR ?\fIon|off\fR?\fR
This turns on or off the dumping of the captured  packets  to  a file.   The
name of the capture file is configured through \fBfconfigure\fR with the
\fI-savefile\fR option.  If neither on nor off are specified, then the current
state is returned.
.TP
\fBdatalink\fR \fIpcapChannel\fR\fR
This calls pcap_datalink which returns the link layer type of the
\fIpcapChannel\fR.  The return value is a list.  The first element of the list is
a string representing the name of the datalink.  This corresponds to what is
listed in the pcap man page.  E.g., DLT_EN10MB.  The second element of the
list is a longer version of the datalink that is more human readable.  E.g.,
Ethernet.
.TP
\fBdump_open\fR \fIpcapChannel\fR \fIdumpFileName\fR\fR
.TP
\fBdump\fR \fIpcap_dumper\fR \fIpacket\fR\fR
.TP
\fBdump_close\fR \fIpcap_dumper\fR\fR
.TP
\fBversion\fR \fR
This calls pcap_lib_version which returns a string containing version
information of the pcap library.
.SH "CONFIGURATION OPTIONS"
The \fBfconfigure\fR command can be used to query and modify several
parameters of the channel created by \fBpcap_open\fR.
.TP
\fI-savefile fileName\fR
The \fI-savefile\fR option specifies the name of a file that is to be used to
save dumped packets to.  This option does not actually start dumping data to
the file.  The \fBsavefile\fR command needs to be called to start saving
captured packets.
.sp
Attempts to change the \fI-savefile\fR while packets are being dumped will result in
an error.
.sp
The value of \fI-savefile\fR defaults to an empty string.
.TP
\fI-filter filter\fR
The \fI-filter\fR option allows the filter used by pcap to be changed.  This
option corresponds to the \fI-filter\fR option of the \fBpcap_open\fR command.
By default, the filter captures all packets.
.SH "EXAMPLE"
.SH "LIMITATIONS"
.SH "SEE ALSO"
tcpdump, pcap(3), fconfigure(n)
.SH "COPYRIGHT"
.nf
Copyright (c) 2001-2005 by Todd J Martin <todd.martin@acm.org>
.fi
